package sample;                      /*                           */
                                                 /*                           */
import java.util.Date;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import android.content.Context;
import android.os.Environment;


public final class FileSave {

    private static final boolean IS_PRODUCT = false;

    private static final SimpleDateFormat FILE_NAME_FORMAT = new SimpleDateFormat("yyyyMMdd");

    private static final SimpleDateFormat LOG_PREFIX_FORMAT = new SimpleDateFormat("HH:mm:ss.SSS ");

    private static FileSave logger;

    private final String directoryPath;

    private File directory = null;

    private FileSave(Context context) {
        directoryPath = Environment.getExternalStorageDirectory().getParent() + File.separator + "logs";
        checkMediaMounted();
    }

    public static FileSave getInstance(Context context) {
        if (logger == null) {
            logger = new FileSave(context);
        }
        return logger;
    }

    public void write(final String log) {
                                                 /*                           */
        if (IS_PRODUCT || directory == null && !checkMediaMounted()) {
            return;
        }

        Date date = new Date();
        File file = new File(directoryPath + File.separator + FILE_NAME_FORMAT.format(date) + ".txt");

        try {
            FileWriter writer = new FileWriter(file, true);
            writer.write(LOG_PREFIX_FORMAT.format(date));
            writer.write(log);
            writer.write(System.getProperty("line.separator"));
            writer.close();
        } catch (FileNotFoundException e) {
            throw new RuntimeException(e);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
                                                 /*                           */
                                                 /*                           */
    private boolean checkMediaMounted() {
                                                 /*                           */
        if (!Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState())) {
            return false;
        }

                                                 /*                           */
        directory = new File(directoryPath);
        if (!directory.exists()) {
            directory.mkdirs();
        }
        return true;
    }
}