/******************************************************************************/
/*                                                                            */
/* 名    称 :  ＭａｉｎＡｃｔｉｖｉｔｙ.ｊａｖａ                              */
/*                                                                            */
/* 機    能 :  エレキジャック特設記事用サンプルプログラム。                   */
/*                                                                            */
/* ＣＱ出版 エレキジャック  特設記事                                          */
/*                                                                            */
/*       ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■       */
/*       ■■■■■                                          ■■■■■       */
/*-      ■■■■■    アンドロイド（スマホ）でｍｙ実験室    ■■■■■       */
/*       ■■■■■                                          ■■■■■       */
/*       ■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■       */
/*                                                                            */
/*                                                                            */
/* 【プログラムの運転概要】                                                   */
/*  このプログラムはホストモードでＵＳＢに接続したマイコンと通信をします。    */
/*  マイコンはＨＩＤデバイス（キーボード等）の文字入力用デバイスを想定して    */
/*  いますので、テキストエディット（文字入力欄）へのデータ入力が主になります。*/
/*                                                                            */
/*                                                                            */
/*                                                                            */
/* 【特記事項】                                                               */
/*                                                                            */
/*  このソースコードにはネット上で公開されている資料を使っています。          */
/*                                                                            */
/*  出展元は本誌を参照して下さい。                                            */
/*                                                                            */
/*                               Copyright(c)  2012  by  Yoshirou Ishigami    */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
package sample;                                  /*                           */
import java.io.File;                             /*                           */
import java.io.FileWriter;                       /*                           */
import java.io.IOException;                      /*                           */
import java.net.DatagramPacket;                  /*                           */
import java.net.DatagramSocket;                  /*                           */
import java.net.InetSocketAddress;               /*                           */
                                                 /*                           */
import java.text.SimpleDateFormat;               /*                           */
import java.util.Calendar;                       /*                           */
import java.util.Date;                           /*                           */
import sample.pic2Android.R;                     /*                           */
                                                 /*                           */
import android.os.Bundle;                        /*                           */
import android.os.Environment;                   /*                           */
import android.annotation.SuppressLint;          /*                           */
import android.app.AlarmManager;                 /*                           */
import android.app.PendingIntent;                /*                           */
import android.content.Context;                  /*                           */
import android.content.Intent;                   /*                           */
import android.content.SharedPreferences;        /*                           */
import android.widget.Toast;                     /*                           */
import android.text.InputType;                   /*                           */
import android.view.KeyEvent;                    /*                           */
                                                 /*                           */
import android.app.Activity;                     /*                           */
import android.graphics.Color;                   /*                           */
import android.os.SystemClock;                   /*                           */
import android.view.Menu;                        /*                           */
import android.view.View;                        /*                           */
import android.view.View.OnKeyListener;          /*                           */
import android.widget.Button;                    /*                           */
import android.widget.Chronometer;               /*                           */
import android.widget.EditText;                  /*                           */
import android.widget.TextView;                  /*                           */
import android.widget.Toast;                     /*                           */
                                                 /*                           */
@SuppressLint({ "ParserError", "ParserError" })  /*                           */
                                                 /*                           */
                                                 /*                           */
public class MainActivity extends Activity       /*                           */
{                                                /*                           */
/*----------------------------------------------------------------------------*/
/*-                他の関数等へ引数として渡す変数を宣言する。                -*/
/*-                                                                          -*/
/*-  tx_buff : 領域の宣言では 10 byteの領域を確保していますが大きくする事も  -*/
/*-            可能ですので自分で調整して下さい。                            -*/
/*-            但し、送信するデータの数（パケットデータ数）はここで確保した  -*/
/*-            データ領域そのままになりますのでこの点は承知して使いましょう。-*
/*-                                                                          -*/
/*-  udp_data: 領域の宣言では tx_buff の領域を同じにしてありますが、必須では -*/
/*-            有りませんので自分で調整をして下さい。                        -*/
/*-            このプログラムでは文字入力欄の文字列をＵＤＰデータの送信関数  -*/
/*-            に引数として渡してます。                                      -*
/*-                                                                          -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
     public  String  fname_log  =  "" ;          /* ＳＤカードへの記録ファイル*/
                                                 /* 名称の編集領域。          */
                                                 /*                           */
     public  String  edit_Data  =  "" ;          /* ＨＩＤからの入力データを  */
                                                 /* 編集する領域。            */
                                                 /*                           */
     public final byte[] tx_buff  =              /* 送信データ用領域を確保。  */
     { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 } ; /*                           */
                                                 /*                           */
     public byte[] udp_data =                    /* データ送信関数への引数とし*/
     { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 } ; /* て確保する。              */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-                   プログラムで使用する変数を宣言する。                   -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
     private  int   pause       =   0 ;          /* クロノメータ一時停止      */
     private  int   interval    =  10 ;          /* 記録の間隔秒数            */
     private  int   sd_check    =   0 ;          /* ＳＤカード確認            */
     private  long  firstTime   =   0 ;          /* 記録開始時間              */
     private  long  repeatTime  =  10 ;          /* 起動間隔時間（msec)       */
                                                 /*                           */
     final Context context = this;               /* contextを格納             */
                                                 /*                           */
     private  PendingIntent almSender ;          /* アラーム呼出用sender      */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-                  アクティビティの表示・運転を開始する。                  -*/
/*----------------------------------------------------------------------------*/
     @Override                                   /*                           */
     public void onCreate(                       /*                           */
                     Bundle savedInstanceState ) /*                           */
      {                                          /*                           */
                                                 /*                           */
       super.onCreate( savedInstanceState ) ;    /*                           */
                                                 /*                           */
       setContentView( R.layout.activity_main ); /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-                ウィジットへアクセスするための定義をする。                -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
       final Chronometer cr1 = (Chronometer)findViewById(R.id.chronometer1 );
       final Button b_start  = (Button)     findViewById(R.id.Button_start );
       final Button b_stop   = (Button)     findViewById(R.id.Button_stop  );
       final Button b_reset  = (Button)     findViewById(R.id.Button_reset );
       final Button b_up     = (Button)     findViewById(R.id.Button_UP    );
       final Button b_down   = (Button)     findViewById(R.id.Button_DWN   );
       final TextView Text02 = (TextView)   findViewById( R.id.textView2   );
       final TextView Text03 = (TextView)   findViewById( R.id.textView3   );
       final EditText edittext1 = (EditText) findViewById( R.id.editText1  );
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-               ＨＩＤデバイスから文字入力をする準備をする。               -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
       edittext1.setInputType(                   /* データ入力欄は文字の入力を*/
                   InputType.TYPE_CLASS_TEXT ) ; /* する。（数値ではない）    */
                                                 /*                           */
       edittext1.requestFocus();                 /* フォーカスをセット。      */
                                                 /*                           */
       Text02.setBackgroundColor( Color.WHITE ); /* 背景の表示色を設定する。  */
       Text03.setBackgroundColor( Color.WHITE ); /*           "               */
                                                 /*                           */
       Text02.setText( " 00  " ) ;               /* データ表示欄を初期化。    */
       Text03.setText( "0.000v" ) ;              /* データ表示欄を初期化。    */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-             ＳＤカードが装着されて使用可能な状態を確認する。             -*/
/*-  確認の方法は、USB-HID_log の名称でフォルダが作成できれば可と判断します。-*/
/*-  http://blog.caldia.org/2012/04/sd.html                                  -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
       String  sd_card  =                        /* ＳＤカードのシステム名称を*/
          Environment.getExternalStorageState(); /* 文字列で取得する。        */
                                                 /*                           */
       if( Environment.MEDIA_MOUNTED.equals(     /* ＳＤカードは実装済みか？  */
                                      sd_card )) /*          "                */
        {                                        /* はい。                    */
                                                 /*                           */
         if( ! Environment.                      /* 読み込み専用では無い？    */
                MEDIA_MOUNTED_READ_ONLY.equals(  /*         "                 */
                                      sd_card )) /*         "                 */
          {                                      /* はい。                    */
                                                 /*                           */
           File ext_sd_card = Environment.       /* ＳＤカードのFileを格納。  */
                  getExternalStorageDirectory(); /* ※ファイルアクセスに使用。*/
                                                 /*                           */
           File folder = new File(               /* フォルダ名称を格納する。  */
                          ext_sd_card ,          /* ※ＳＤカード内です。      */
                          "/USB-HID_log" ) ;     /*         "                 */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-         ＳＤカード内にデータフォルダが存在しない時の処理をする。         -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
           if( ! folder.exists() )               /* データフォルダは無しか？  */
            {                                    /* はい。                    */
             boolean isMkDirs =                  /* 新規にフォルダを作成する。*/
                              folder.mkdirs();   /*            "              */
                                                 /*                           */
             if( ! isMkDirs )                    /* フォルダが作れなかった？  */
              {                                  /* はい。                    */
                                                 /*                           */
               Toast.makeText(                   /* メッセージを表示する。    */
                     getBaseContext()  ,         /* ※警告メッセージ。        */
                     "Can't use SD card" ,       /*                           */
                     Toast.LENGTH_LONG ).show(); /*                           */
                                                 /*                           */
              }                                  /*                           */
/*----------------------------------------------------------------------------*/
/*-              データフォルダの作成に成功した時の処理をする。              -*/
/*----------------------------------------------------------------------------*/
             else                                /* フォルダが作成出来た？    */
              {                                  /* はい。                    */
                                                 /*                           */
               File  new_name  =                 /* ファイル名称を格納する。  */
                      new File( folder ,         /* ※新規に作成するファイル  */
                                 "log.csv" ) ;   /*   の名称です。 log.csv    */
                                                 /*                           */
               try                               /* エラーの可能性がある処理。*/
                {                                /*                           */
                                                 /*                           */
                 new_name.createNewFile();       /* 新規にファイルを作成する。*/
                                                 /*                           */
                 Toast.makeText(                 /* ファイル作成の成功を表示。*/
                     getBaseContext()  ,         /*           "               */
                     "Success make log file" ,   /*           "               */
                     Toast.LENGTH_LONG ).show(); /*           "               */
                }                                /*                           */
               catch (IOException e)             /* ファイル作成に失敗した時。*/
                {                                /*                           */
                                                 /*                           */
                 Toast.makeText(                 /* ファイル作成の失敗を表示。*/
                     getBaseContext()  ,         /*           "               */
                     "Can't  make file" ,        /*           "               */
                     Toast.LENGTH_LONG ).show(); /*           "               */
                                                 /*                           */
                 e.printStackTrace();            /*                           */
                                                 /*                           */
                }                                /*                           */
                                                 /*                           */
              }                                  /*                           */
                                                 /*                           */
            }                                    /*                           */
/*----------------------------------------------------------------------------*/
/*-        既にＳＤカード内にデータフォルダが存在した時の処理をする。        -*/
/*----------------------------------------------------------------------------*/
           else                                  /* データフォルダは有りか？  */
            {                                    /* はい。                    */
                                                 /*                           */
             fname_log  =  folder.toString() +   /* ログファイル名を編集格納。*/
                                   "/log.csv" ;  /* ※ log.csv                */
             try                                 /*                           */
              {                                  /*                           */
                                                 /*                           */
               FileWriter writer =               /* ファイルへのライタを準備。*/
                  new FileWriter( fname_log  ,   /*            "              */
                                      true  ) ;  /*            "              */
                                                 /*                           */
               Date date = new Date();           /* 現在の時刻を格納する。    */
                                                 /*                           */
               SimpleDateFormat sdfmt  =         /* 時刻の編集書式を格納する。*/
                    new SimpleDateFormat(        /*        "                  */
                       "yyyy/MM/dd \n" ) ;       /* ※年/月/日の様式          */
                                                 /*                           */
               String fmt_time =                 /* 時刻を文字列に格納する。  */
                           sdfmt.format( date ); /*          "                */
                                                 /*                           */
               writer.write( fmt_time ) ;        /* ファイルへ書き込みをする。*/
                                                 /*                           */
               writer.close();                   /* 書き込みを終了する。      */
                                                 /*                           */
               sd_check  =  1 ;                  /* ＳＤカード使用可にセット。*/
                                                 /*                           */
              }                                  /*                           */
             catch (IOException e)               /*                           */
              {                                  /*                           */
               e.printStackTrace();              /*                           */
              }                                  /*                           */
                                                 /*                           */
             Toast.makeText(                     /* メッセージを表示する。    */
                     getBaseContext()  ,         /*           "               */
                     "Detected log File" ,       /*           "               */
                     Toast.LENGTH_LONG ).show(); /*           "               */
                                                 /*                           */
            }                                    /*                           */
                                                 /*                           */
          }                                      /*                           */
                                                 /*                           */
        }                                        /*                           */
                                                 /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-               クロノメータのスタートボタン処理を実行する。               -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
       b_start.setOnClickListener(               /*                           */
                                                 /*                           */
         new View.OnClickListener()              /*                           */
          {                                      /*                           */
                                                 /*                           */
           public void onClick( View v )         /*                           */
            {                                    /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-            既に起動済みの場合はそのまま継続で表示を開始する。            -*/
/*----------------------------------------------------------------------------*/
             if( pause ==  1  )                  /* 一時停止か？              */
              {                                  /* はい。                    */
                                                 /*                           */
               cr1.start() ;                     /* 運転を再開する。          */
                                                 /*                           */
              }                                  /*                           */
/*----------------------------------------------------------------------------*/
/*-                          スタートの処理をする。                          -*/
/*----------------------------------------------------------------------------*/
             else                                /*                           */
              {                                  /*                           */
/*----------------------------------------------------------------------------*/
/*-                                                                          -*/
/*-          画面へ表示するクロノメータ（秒単位）の表示を開始する。          -*/
/*-                                                                          -*/
/*-  注意事項：クロノメータは経過秒数を画面に表示する機能だけで、アラームマネ-*/
/*-  ジャとは関連していません。                                              -*/
/*-                                                                          -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
               cr1.setBase(                      /* クロノメータの運転開始。  */
                  SystemClock.elapsedRealtime()  /* 起動時間をリセット。      */
                                            ) ;  /*          "                */
               cr1.start() ;                     /* 運転開始命令。            */
                                                 /*                           */
               pause  =  1 ;                     /* 起動済みのセット。        */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-                                                                          -*/
/*-                 アラームマネージャの運転条件を準備する。                 -*/
/*-                                                                          -*/
/*-  このアラームマネージャは画面に表示される機能とは別のスレッドで運転され  -*/
/*-  ますので、以後、定期的に処理を行うプログラムはAlarmReceiver.javaの中に  -*/
/*-  記述をします。                                                          -*/
/*-                                                                          -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
               Intent intent =  new Intent(      /* アラームマネージャ用Intent*/
                       getApplicationContext(),  /* を作成する。              */
                       AlarmReceiver.class ) ;   /* ※引数に使う。            */
                                                 /*                           */
               almSender =                       /* ブロードキャストでアラーム*/
                   PendingIntent.getBroadcast(   /* マネージャを起動する条件を*/
                       getApplicationContext() , /* 作成する。                */
                       0 , intent ,              /* タイマーでintentを発信    */
                       PendingIntent.            /*           "               */
                       FLAG_CANCEL_CURRENT );    /*           "               */
                                                 /*                           */
               Calendar calendar =               /* 現在の時刻（カレンダー）を*/
                        Calendar.getInstance() ; /* 取得する。                */
                                                 /*                           */
               calendar.setTimeInMillis(         /* 秒数に換算する。（ミリ秒）*/
                   System.currentTimeMillis() ); /*            "              */
                                                 /*                           */
               calendar.add(                     /*                           */
                              Calendar.SECOND ,  /* 現在の時刻に運転間隔を加算*/
                              interval ) ;       /* して格納する。            */
                                                 /*                           */
               firstTime  =                      /* 起動時刻を格納。          */
                    calendar.getTimeInMillis() ; /* ※ミリ秒                  */
                                                 /*                           */
               repeatTime = (long)interval*1000 ;/* 運転間隔を格納（秒数）    */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-              アラームマネージャを運転するための条件を設定。              -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
               AlarmManager alarmManager =       /* アラームマネージャを準備。*/
                (AlarmManager) getSystemService( /*           "               */
                        Context.ALARM_SERVICE ); /*           "               */
                                                 /*                           */
               alarmManager.setRepeating(        /* アラームマネージャの運転  */
                       AlarmManager.RTC ,        /* 条件をセットする。        */
                       firstTime  ,              /* 起動時刻                  */
                       repeatTime ,              /* 繰り返す間隔              */
                       almSender    );           /* 起動ターゲット。          */
                                                 /* AlarmReceiver.class       */
                                                 /*                           */
               Toast.makeText(                   /* メッセージを表示する。    */
                    getApplicationContext() ,    /*         "                 */
                   "Alarm Repeat Setting"  ,     /*         "                 */
                    Toast.LENGTH_SHORT ).show(); /*         "                 */
                                                 /*                           */
              }                                  /*                           */
            }                                    /*                           */
          }                      ) ;             /*                           */
                                                 /*                           */
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
       b_stop.setOnClickListener(                /*                           */
                                                 /*                           */
         new View.OnClickListener()              /*                           */
          {                                      /*                           */
           public void onClick(View v)           /*                           */
            {                                    /*                           */
                                                 /*                           */
             cr1.stop() ;                        /*                           */
                                                 /*                           */
             pause  =  1 ;                       /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/
                                                 /*                           */
             AlarmManager alarmManager  =        /*                           */
               (AlarmManager) getSystemService(  /*                           */
                      Context.ALARM_SERVICE ) ;  /*                           */
                                                 /*                           */
             if( almSender != null )             /*                           */
              {                                  /*                           */
                                                 /*                           */
               alarmManager.cancel( almSender ); /*                           */
                                                 /*                           */
              }                                  /*                           */
            }                                    /*                           */
          }                                  );  /*                           */
                                                 /*                           */
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
       b_reset.setOnClickListener(               /*                           */
                                                 /*                           */
         new View.OnClickListener()              /*                           */
          {                                      /*                           */
           public void onClick(View v)           /*                           */
            {                                    /*                           */
                                                 /*                           */
             cr1.stop() ;                        /*                           */
                                                 /*                           */
             cr1.setBase(                        /*                           */
                  SystemClock.elapsedRealtime()  /*                           */
                                            ) ;  /*                           */
             pause  =  0 ;                       /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/
                                                 /*                           */
             AlarmManager alarmManager  =        /*                           */
               (AlarmManager) getSystemService(  /*                           */
                      Context.ALARM_SERVICE ) ;  /*                           */
                                                 /*                           */
             if( almSender != null )             /*                           */
              {                                  /*                           */
                                                 /*                           */
               alarmManager.cancel( almSender ); /*                           */
                                                 /*                           */
              }                                  /*                           */
            }                                    /*                           */
         }                                    ); /*                           */
                                                 /*                           */
/******************************************************************************/
/*                                                                            */
/*             Ｉｎｔｅｒｖａｌ調整用のＵＰボタン操作を処理する。             */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
       b_up.setOnClickListener(                  /* Ｕｐボタンの操作処理。    */
         new View.OnClickListener()              /*                           */
        {                                        /*                           */
                                                 /*                           */
         public void onClick( View v )           /* ボタンの操作を監視する。  */
          {                                      /*                           */
                                                 /*                           */
           if( interval < 3600 )                 /* 設定値が範囲内か？        */
            {                                    /* はい。                    */
             interval ++ ;                       /* Intervalを加算する。      */
            }                                    /*                           */
                                                 /*                           */
           Text02.setText(                       /*                           */
                   String.format( " %1$02d  " ,  /*                           */
                                   interval )) ; /*                           */
           }                                     /*                           */
                                                 /*                           */
        }                                   ) ;  /*                           */
                                                 /*                           */
/******************************************************************************/
/*                                                                            */
/*           Ｉｎｔｅｒｖａｌ調整用のＤｏｗｎボタン操作を処理する。           */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
       b_down.setOnClickListener(                /* Ｄｏｗｎボタンの操作処理。*/
         new View.OnClickListener()              /*                           */
        {                                        /*                           */
                                                 /*                           */
         public void onClick( View v )           /* ボタンの操作を監視する。  */
          {                                      /*                           */
                                                 /*                           */
           if( interval > 1  )                   /* 設定値が範囲内か？        */
            {                                    /* はい。                    */
             interval -- ;                       /* Intervalを加算する。      */
            }                                    /*                           */
                                                 /*                           */
           Text02.setText(                       /*                           */
                   String.format( " %1$02d  " ,  /*                           */
                                   interval )) ; /*                           */
           }                                     /*                           */
                                                 /*                           */
        }                                   ) ;  /*                           */
                                                 /*                           */
/******************************************************************************/
/*                                                                            */
/*                 キーボード入力欄へのデータ入力を監視する。                 */
/*                                                                            */
/*  ここでは、USBで接続したＨＩＤデバイスからのデータ入力を監視しまる。       */
/*                                                                            */
/*  入力データがEnterの時にはデータ入力が終了したものとして処理を開始します。 */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
       edittext1.setOnKeyListener(               /*                           */
                            new OnKeyListener()  /*                           */
        {                                        /*                           */
         public boolean onKey(                   /*                           */
          View v, int keyCode , KeyEvent event ) /*                           */
          {                                      /*                           */
/*----------------------------------------------------------------------------*/
/*-                Ｅｎｔｅｒボタンが押された時の処理をする。                -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
           if(( event.getAction() ==             /* ボタンが押された？        */
                      KeyEvent.ACTION_DOWN ) &&  /*                           */
              ( keyCode ==                       /* Ｅｎｔｅｒボタンか？      */
                      KeyEvent.KEYCODE_ENTER ))  /*                           */
            {                                    /* はい。                    */
                                                 /*                           */
             SharedPreferences set_data  =       /* 共有ファイルの名称をセット*/
                   getSharedPreferences(         /* する。                    */
                         "HID-USB_preferences" , /* 名称 HID-USB_preferences  */
                          MODE_PRIVATE |         /* 誰でも読み書き可能にセット*/
                          MODE_WORLD_WRITEABLE | /*            "              */
                          MODE_WORLD_READABLE ); /*            "              */
                                                 /*                           */
             SharedPreferences.Editor editor =   /* ファイルエディタを準備。  */
                               set_data.edit() ; /*         "                 */
                                                 /*                           */
             editor.putInt(                      /* ＳＤカードの装着状態を記入*/
                            "SD_CHECK",          /* する。                    */
                             sd_check  ) ;       /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-            ＨＩＤから入力されたデータを文字列として格納する。            -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
             edittext1.selectAll();              /* 入力文字全てを選択する。  */
                                                 /*                           */
             edit_Data  =  edittext1.getText().  /* 入力された文字列を格納する*/
                                   toString() ;  /* String型に変換する。      */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/
                                                 /*                           */
             Text03.setText( edit_Data ) ;       /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/
                                                 /*                           */
             editor.putString( "EDIT_DATA" ,     /* 入力文字列を記入する。    */
                                edit_Data  ) ;   /*         "                 */
                                                 /*                           */
             editor.putString( "LOG_FILE" ,      /* ログファイルの名称を格納す*/
                                fname_log  ) ;   /* る。※フルパスの名称です。*/
                                                 /*                           */
             editor.commit();                    /* 書き込みを完了する。      */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-       画面の中で唯一ＨＩＤからの入力を可能にしてる欄を初期化する。       -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
             edittext1.getEditableText().clear();/* 入力欄を空白にする。      */
                                                 /*                           */
//           edittext1.requestFocus();           /* フォーカスを入力欄に移動。*/
                                                 /* ※これは不要のようです。  */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-                   文字入力のデータをＵＤＰで送信する。                   -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
             udp_data =                          /* エディット欄の文字列を送信*/
                      edit_Data.getBytes() ;     /* データとして格納する。    */
                                                 /*                           */
             tx_udp( udp_data ) ;                /* ＵＤＰデータで送信する。  */
                                                 /*                           */
                                                 /*---------------------------*/
                                                 /*                           */
             return ( true  ) ;                  /* 返却値をリターンする。    */
                                                 /*                           */
            }                                    /*                           */
                                                 /*                           */
           return ( false ) ;                    /* 返却値をリターンする。    */
                                                 /*                           */
          }                                      /*                           */
       }                                    ) ;  /*                           */
                                                 /*                           */
    }                                            /*                           */
/******************************************************************************/
/*                                                                            */
/*                 ■マイコンへＵＤＰパケットを送信する関数■                 */
/*                                                                            */
/*  データを送信するアドレスは本分に固定値で書いていますので、変更したい時は  */
/*  書き換えてください。                                                      */
/*  IP: 192.168.1.200        ポート番号: 50001                                */
/*                                                                            */
/*  【注意点】                                                                */
/*  送信するデータの数については、このソースコードの先頭部分で tx_buff[] を   */
/*  宣言してしますが、この宣言した配列の数が送信データのデータ長となります。  */
/*  送信データ数がここで宣言した数よりも多くしたい時には自分で書き変えてくだ  */
/*  さい。                                                                    */
/*  本プログラムではEditTextの欄に入力されるデータの文字数を８文字と想定をし  */
/*  ているので配列を１０個の固定にしてあります。                              */
/*   public final byte[] tx_buff  =                 送信データ用領域を確保。  */
/*   { 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 } ;                              */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
     public void tx_udp( byte arg[] )            /* ＵＤＰデータの送信処理    */
      {                                          /*                           */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-                  UDPパケットに含めるデータを編集する。                   -*/
/*-                                                                          -*/
/*- 送信するデータを編集したい時にはここでします。                           -*/
/*-                                                                          -*/
/*- 送信するデータ数を制限したい時もここでします。                           -*/
/*-                                                                          -*/
/*- 【サンプルのデータの関する仕様】                                         -*/
/*-                                                                          -*/
/*- 先頭の１バイトはデータの属性として送信しています。                       -*/
/*- 例： 1 ＝ ＤＣ電圧の文字データ                                           -*/
/*-                                                                          -*/
/*-                                                                          -*/
/*-                                                                          -*/
/*-                                                                          -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
        int  i  ;                                /*                           */
                                                 /*                           */
        int  wk =  arg.length  ;                 /*                           */
                                                 /*                           */
        if( wk > 8 ) { wk  =  8 ;  }             /*                           */
                                                 /*                           */
        for( i = 0 ; i < wk ; i ++ )             /*                           */
         {                                       /*                           */
          tx_buff[ i + 1 ] = ( byte )arg[ i ] ;  /* 入力文字の値。            */
         }                                       /*                           */
                                                 /*                           */
        tx_buff[ 0 ]  =  ( byte ) 0x01 ;         /* データの属性を格納する。  */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-                         UDPパケットを生成する。                          -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
      try                                        /* 例外発生を含む処理の実行  */
       {                                         /*                           */
/*----------------------------------------------------------------------------*/
/*-  UDPパケットを送信する相手先となるアドレスとポート番号でソケットを準備。 -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
        InetSocketAddress remoteAddress =        /* ソケットを用意する。      */
                    new InetSocketAddress(       /* IP Address: 192.168.1.200 */
                     "192.168.1.200" , 50001 );  /* Socket No : 50001         */
                                                 /*                           */
        DatagramPacket sendpacket =              /*                           */
            new DatagramPacket(                  /*                           */
                         tx_buff  ,              /* データの格納領域。        */
                         tx_buff.length ,        /*    "    長さ。            */
                         remoteAddress  );       /* 送信先のアドレス。        */
                                                 /*                           */
/*----------------------------------------------------------------------------*/
/*-      DatagramSocketインスタンスを生成して、UDPパケットを送信する。       -*/
/*----------------------------------------------------------------------------*/
                                                 /*                           */
        new DatagramSocket().send( sendpacket ); /* データを送信する。        */
                                                 /*                           */
       }                                         /*                           */
      catch (Exception e)                        /*                           */
       {                                         /*                           */
                                                 /*                           */
                                                 /*                           */
       }                                         /*                           */
                                                 /*                           */
     }                                           /*                           */
                                                 /*                           */
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
     @Override                                   /*                           */
     protected void onDestroy()                  /*                           */
      {                                          /*                           */
                                                 /*                           */
       AlarmManager alarmManager  =              /*                           */
             (AlarmManager) getSystemService(    /*                           */
                      Context.ALARM_SERVICE ) ;  /*                           */
                                                 /*                           */
       if( almSender != null )                   /*                           */
        {                                        /*                           */
                                                 /*                           */
         alarmManager.cancel( almSender );       /*                           */
                                                 /*                           */
        }                                        /*                           */
       super.onDestroy();                        /*                           */
                                                 /*                           */
      }                                          /*                           */
                                                 /*                           */
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*                                                                            */
/******************************************************************************/
                                                 /*                           */
     @Override                                   /*                           */
     public boolean onCreateOptionsMenu(         /*                           */
                                 Menu menu )     /*                           */
      {                                          /*                           */
                                                 /*                           */
       getMenuInflater().inflate(                /*                           */
                 R.menu.activity_main , menu ) ; /*                           */
                                                 /*                           */
       return true ;                             /*                           */
                                                 /*                           */
      }                                          /*                           */
                                                 /*                           */
                                                 /*                           */
}                                                /*                           */
/******************************************************************************/
